<?php
/**
* @package		Marco's Pinned Site for IE9
* @copyright	Copyright (C) 2011 mmleoni web consulting. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
*/


// no direct access
defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.menu');
jimport('joomla.application.site');
jimport('joomla.plugin.plugin');
jimport('joomla.environment.browser');
//error_reporting(E_ALL);

class  plgSystemMarcopinnedsite extends JPlugin {

	function onAfterRender(){
		$browser = &JBrowser::getInstance();
		if (($browser->getBrowser() != 'msie')&&($browser->getMajor()<=9)){
			return; // Don't run if not IE9
		}
		//print_r($browser);die();
		
		$app = &JFactory::GetApplication();
		if ($app->isAdmin()) {
			return; // Don't run in admin
		}
		
		$doc = &JFactory::getDocument();
		$doctype = $doc->getType();
		if ( $doctype !== 'html' ){
			return; // Don't run if no html
		}
		
		$url = JURI::base();

		
		//
		// Generate Static Jump Table
		// head metadata
		//
				
		// Get Menu Items
		$items = &JSite::getMenu();
		$rows = $items->getItems('menutype', $this->params->get('menutype'));
		if($rows == null) $rows=array();
		//var_dump($rows);die();
		
		$conf = &JFactory::getConfig();
		$this->params->def('menutype', 'pinnedmenu');
		$this->params->def('menu_images', 0);
		$this->params->def('startLevel', 0);
		$this->params->def('endLevel', 0);
		$this->params->def('application_name', $conf->getValue( 'config.sitename' ));
		$this->params->def('application_tooltip', $conf->getValue( 'config.MetaDesc' ));
		$this->params->def('navbutton_color', '#FF3300');
		$this->params->def('application_starturl', '/');
		$this->params->def('application_width', 0);
		$this->params->def('application_height', 0);
		$this->params->def('drawdiv', 1);
		$this->params->def('loaddivcss', 1);
		$this->params->def('divdragicon', 'Drag the icon, please!');

		$meta = array();

		$meta[] = "<meta name=\"application-name\" content=\"{$this->params->get('application_name')}\" />";
		$meta[] = "<meta name=\"msapplication-tooltip\" content=\"{$this->params->get('application_tooltip')}\" />";
		if ($this->params->get('application_width') && $this->params->get('application_height')){
			$meta[] = "<meta name=\"msapplication-window\" content=\"width={$this->params->get('application_width')};height={$this->params->get('application_height')}\" />";
		}
		$meta[] = "<meta name=\"msapplication-navbutton-color\" content=\"{$this->params->get('navbutton_color')}\" />";
		
		$application_starturl = $this->params->get('application_starturl');
		if ( ($application_starturl == '/') || ($application_starturl == './') ){
			$application_starturl = $url;
		}elseif( !preg_match( '/^http/', $application_starturl) ){
			$application_starturl = $url . preg_replace ( '/^\//', '', $application_starturl);
		}
		$meta[] = "<meta name=\"msapplication-starturl\" content=\"{$application_starturl}\" />";

		foreach ($rows as $row){
			if(!$row->published) continue;
			$pr = $items->getParams($row->id);
			// <meta name="msapplication-task" content="name=Check Order Status;action-uri=./orderStatus.aspx?src=IE9;icon-uri=./favicon.ico" />
			$ico = ';icon-uri=';
			if ($this->params->get('menu_images')){
				$icofile = $pr->get('menu_image', '');
				if ($icofile != '-1') $ico .= "{$url}images/stories/" . $icofile;
			}
			
			$name = str_replace(';', '.', $row->name);
			$link = $row->link;
			switch ($row->browserNav){
				case 1: // new window with navigator
					$target = 'window'; // a new Pinned Site window
				break;
				case 2: // new window without navigator
					$target = 'tab'; // a new tab in the current window
				break;
				default:
					$target = 'self'; // the current tab
			}
			$target = ';window-type=' . $target;
			$meta[] =  "<meta name=\"msapplication-task\" content=\"name={$name};action-uri={$url}{$link}{$ico}{$target}\" />";
		}
		
		//$meta[] =  "<script type=\"text/javascript\" src=\"plugins/system/marcopinnedsite.js\"></script>";
		if($this->params->get('drawdiv') && $this->params->get('loaddivcss')){
			$meta[] = '<link rel="stylesheet" type="text/css" href="' . $url. 'plugins/system/marcopinnedsite.css" />';
		}
		
		
		//
		// Generate Dynamic Jump Table
		// js
		//
		if($this->params->get('dynjump')){
			$uri =& JURI::getInstance();
			$port = ($uri->getPort() ? ':' . $uri->getPort() : '');
			$url = sprintf('%s://%s%s/', $uri->getScheme(),  $uri->getHost(), $port);

			require_once (JPATH_SITE.DS.'modules'.DS.'mod_latestnews'.DS.'helper.php');
			$list = modLatestNewsHelper::getList($this->params);
			if($list == null) $list=array();
			$pinnedname = addslashes(trim( $this->params->get('pinnedname', 'Latest News') ));
			
			$meta[] =  "<script type='text/javascript'>"; 
			$meta[] =  "function initJump(){";
			$meta[] =  "	try {";
			$meta[] =  "		window.external.msSiteModeClearJumpList();";
			$meta[] =  "		window.external.msSiteModeCreateJumplist('{$pinnedname}');";
			//foreach($list as $news){
			for($i=count($list)-1;$i>=0;$i--){
				$news=$list[$i];
				$news->text = addslashes($news->text);
				$news->link = addslashes( preg_replace ( '/^\//', '', $news->link) );
				$meta[] =  "		window.external.msSiteModeAddJumpListItem('{$news->text}', '{$url}{$news->link}', '{$url}plugins/system/marcopinnedsite.ico', 'self');";
			}
			$meta[] =  "	} catch (ex) {";
			$meta[] =  "		//alert(ex);";
			$meta[] =  "	}";
			$meta[] =  "}";

			$meta[] =  "initJump();";
		
			$meta[] =  "</script>";
		}	
		
		if($this->params->get('drawdiv')){
			$meta[] =  "<script type='text/javascript'>"; 
			$meta[] =  "window.addEvent('domready', function(){";
			$meta[] =  "	try {";
			$meta[] =  "	        if (window.external.msIsSiteMode()) {";
			$meta[] =  "	            // Continue intialization";
			$meta[] =  "	        }";
			$meta[] =  "	        else {";
			$meta[] =  "	            document.getElementById('divPinSite').style.display = \"block\";";
			$meta[] =  "	        }";
			$meta[] =  "	} catch (e) {";
			$meta[] =  "	        // Fail silently. Pinned Site API not supported.";
			$meta[] =  "	        // alert('Pinned Site API not supported!');";
			$meta[] =  "	}";
			$meta[] =  "})";
			$meta[] =  "function addSite() {";
			$meta[] =  "    try {";
			$meta[] =  "        window.external.msAddSiteMode();";
			$meta[] =  "	} catch (e) {";
			$meta[] =  "        alert(\"This feature is only available in Internet Explorer 9.\");";
			$meta[] =  "    }";
			$meta[] =  "}";
			$meta[] =  "</script>";
		}
		
		
		
		//
		// Insert into page
		//
		//print_r($meta);die();
		$body= &JResponse::getbody();
		$body = str_replace('</head>', implode("\n", $meta)."\n</head>", $body);
		
		if($this->params->get('drawdiv')){
			$div= array();
			$div[]='<div id="divPinSite">';
			$div[]=$this->params->get('divdragicon');
			$div[]='</div>';
			
			$body = preg_replace ("/(<body[^>]*>)/i" , "\\1\n" . implode("\n", $div), $body);
		}
		
		JResponse::setBody($body);
		
	}
	
}


